/*
** tutor11.prg
**
*/

new;
library PDE,pgraph;
PDEset;

#include tutor.inc;

cls;

N = 101;
M = 11;
xstar = 0;
alpha = 0.01;

t = GenerateGrid1(tmin,tmax,M);

proc gridProc(t,i);
  if t <= 0.5;  
    retp(GenerateGrid1(xmin,xmax,N));
  else;
    retp(GenerateGrid3(xmin,xmax,N,xstar,alpha));
  endif;
endp;

call saveGrid(t,&gridProc,"xFile");

call PDE(&aproc,&bproc,&cproc,&dproc,0,&tminbound,&xminbound,&xmaxbound,0,0);
call solvePDE2("xFile","uFile",0.5);

{x1,U1} = readPDE2("xFile","uFile",0.1); 

print "======================================================";
call printfm(x1,1,"*.*lf" ~7 ~2);
print "======================================================";
call printfm(U1,1,"*.*lf" ~7 ~3);

output off;


