/*
** tutor12.prg
**
*/

new;
library PDE,pgraph;
PDEset;

cls;

rndseed 123;

proc aproc(t,x);
  retp(ones(rows(x),1));
endp;

proc bproc(t,x);
  retp(-ones(rows(x),1));
endp;

proc cproc(t,x);
  retp(zeros(rows(x),1));
endp;

proc dproc(t,x);
  retp(zeros(rows(x),1));
endp;

proc InitialGuessSolution(t,x);
  retp(rndn(rows(x),1));
endp;

proc xminBound(t,x);
  retp( zeros(rows(x),1) );
endp;

proc xmaxBound(t,x);
  retp( (exp(1)-1).*ones(rows(x),1 ));
endp;

proc DxminBound(t,x);
  retp( ones(rows(x),1) );
endp;

proc DxmaxBound(t,x);
  retp( ones(rows(x),1) );
endp;

proc SolutionProc(x);
  retp((exp(x)-1));
endp;

_PDE_PrintIters = 50;
_PDE_Elliptic = 1;
_PDE_SaveLastIter = 0;
_fcmptol = 1e-5;

tmin =  0; tmax = 1; M = 501;
xmin =  0; xmax = 1; N =  21;

t = Generategrid1(tmin,tmax,M);
x = GenerateGrid1(xmin,xmax,N);

call PDE(&aproc,&bproc,&cproc,&dproc,0,&InitialGuessSolution,&xminbound,&xmaxbound,0,0);
call solvePDE(t,x,"uFile",0.5);

t = readPDE("uFile","t");
x = readPDE("uFile","x");
U1 = readPDE("uFile","t"|t[1]);
U2 = readPDE("uFile","t"|t[10]);
U3 = readPDE("uFile","t"|t[100]);
U4 = readPDE("uFile","t"|t[rows(t)]);
U = U1~U2~U3~U4;

sol = SolutionProc(x);

graphset;
  _pdate = "";
  _pcross = 1; _pframe = 0; _pnum = 2;
  _pltype = 6|3|3|3|3;
  xy(x,sol~U);

  xy(x,sol~U4);

